function [He,errH,res]=LEMACAFC2(X,nu,fac,nbs,niter,ini,col,H);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%LEMACAFC2 algorithm
%estimate the mixing matrix (He) and plot fit vs iteration number.
%err is the reconstruction error and eH is the NMSE between He and the real mixing matrix H (if H is given)

%X is the observation matrix.
%nu: grid size.
%fac: grid points belong to [-fac; fac]^nbc.
%nbs: sources number.
%ini: Initialisation parameter. if ini=0, initial matrices are loaded from 
%file Lini.mat, othewise, random initialisation is performed and initial
%matrices are saved in Fac.mat.
%niter is the maximal number of iteration allowed to the algorithm.
%col: string defining color, line type and plot symbols of the output plot.
%if given, H is the true mixing matrix to be compared to He in order
%to evaluate the CAF approach. Othewise one MUST NOT declare the H
%argument.
[W]=create_gfT(X,nu,fac);
for r=1:nu
    w=W(:,r);
    T2(:,:,r,:)=create_gfT_2(w,X);
end
%LEMACAFC2
if nargin==7
    H=[];
end
[He,res,errH]=LM_caf_C2(T2,nbs,niter,ini,col,H);

