function [He,errH,res]=LEMACAFC_auto(X,nu,fac,nbs,niter,ini,col,H);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%LEMACAFC algorithm. Allow to choose the derivative order without restriction. 
%By default it is set for order 4. Higher orders are very time consuming.
%It also allows to choose the derivative combinations to be use.
%Note that for order higher than 5 MD1 and T have to be define by the user.
%Otherwise, for order 2 to 5, simply comment and uncomment the line corresponding 
%to the desired version of the algorithm. 

%estimate the mixing matrix (He) and plot fit vs iteration number.
%err is the reconstruction error and eH is the NMSE between He and the real mixing matrix H (if H is given)

%X is the observation matrix.
%nu: grid size.
%fac: grid points belong to [-fac; fac]^nbc.
%nbs: sources number.
%ini: Initialisation parameter. if ini=0, initial matrices are loaded from 
%file Fac.mat, othewise, random initialisation is performed and initial
%matrices are saved in Lini.mat.
%niter is the maximal number of iteration allowed to the algorithm.
%col: string defining color, line type and plot symbols of the output plot.
%if given, H is the true mixing matrix to be compared to He in order
%to evaluate the CAF approach. Othewise one MUST NOT declare the H


%Table of order 2 derivatives (LEMACAFC2) 
%MD1=[0 0; 1 1; 0 1]; % comment/uncomment
%Table of order 3 derivatives (LEMACAFC3) 
%MD1=[0 0 0;0 0 1; 1 1 1;1 1 0]; %comment/uncomment
%Table of order 4 derivatives (LEMACAFC4)
MD1=[0 0 0 0; 0 0 0 1; 0 0 1 1; 0 1 1 1; 1 1 1 1]; %comment/uncomment
%Table of order 5 derivatives (LEMACAFC5)
%MD1=[0 0 0 0 0; 0 0 0 0 1; 0 0 0 1 1; 0 0 1 1 1; 0 1 1 1 1; 1 1 1 1 1]; %comment/uncomment

O1=size(MD1,2);
[M1,Ind1]=table_deriv(O1);

[W]=create_gfT(X,nu,fac);
for r=1:nu
   w=W(:,r);
   %T(:,:,r,:)=create_gfT_auto(w,X,O1,MD1,M1,Ind1); %LEMACAFC2 tensor %comment/uncomment
   %T(:,:,:,r,:)=create_gfT_auto(w,X,O1,MD1,M1,Ind1); %LEMACAFC3 tensor %comment/uncomment
   T(:,:,:,:,r,:)=create_gfT_auto(w,X,O1,MD1,M1,Ind1); %LEMACAFC4 tensor %comment/uncomment
   %T(:,:,:,:,:,r,:)=create_gfT_auto(w,X,O1,MD1,M1,Ind1); %LEMACAFC5 tensor %comment/uncomment
end

%LEMACAFC4
if nargin==7
    H=[];
end
[He,res,errH]=LM_caf_auto(T,nbs,MD1,niter,0,col,H);
