function [He,resn,errH]=LM_caf_C3(T,R,niter,ini,col,Hv);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
errH=[];
warning('off','MATLAB:divideByZero')
rand('state',sum(100*clock));
% tensor dimensions
I=size(T);
% tensor order
D1=I(1);
D2=I(4);

%Loadings intitialisation
%Load initial matrices saved in Fac.mat (if ini=1) or choose random starting matrices
if ini==1
    load Fac
    Le=Lini;
else
    Le=cell(1,6);
    nn=norm(T(:)).^(1/6);
    for d=1:2;
        Le{d}=nn*randn(D1,R);
    end
    for d=3:6;
        Le{d}=nn*rand(D2,R);
    end
    Lini=Le;
    save Fac Lini
end
[Te]=model_caf_C3(Le);

res=Te(:)-T(:);
err_old=res'*res/2;
err_vec=zeros(niter+1,1);
err_new=err_old;
err_rel= abs(err_new-err_old)/err_old;
err_rel_vec=zeros(niter,1);
err_vec(1)=err_old;

[Hess,Jac,grad]=construct_jacobian_caf_C3(Le,T);

eps1=1e-3;
eps2=1e-12;
flag=(max(grad)<eps1);
nu=2;
mu= 2;
it=0;

% loop for estimating the component matrices
while   it<niter   %&& err_new >=1e-20  %&& err_rel>1e-15 %&& mu> 1e-8  && lda> 1e-8 &&flag==0
    it=it+1 ;
    err_old=err_new;
    [Le,err_new,mu,nu,Hess,grad,Jac,flag]=boucle_lm_caf_C3(Le,T,mu,nu,Hess,grad,Jac,eps2,eps1,flag);
    err_rel= abs(err_new-err_old)/err_old;
    err_rel_vec(it)= err_rel;
    err_vec(it+1)=err_new;
end
%solve permutation and scaling ambiguity
a=Le{1};
b=Le{2};
He=a+b*i;
if nargin==6;
    Lf=permscal3({He},{Hv});
    He=Lf{1};
    ee=Hv(:)-He(:);
    errH=ee'*ee/((Hv(:))'*Hv(:));
end
[Te]=model_caf_C3(Le);
res=sum((T(:)-Te(:)).^2);
resn=res/sum(T(:).^2);
%fit plot
figure
semilogy(err_vec(1:it),col)
hold on

