function [L_newv,res,lda_new,nu,Hess,grad,Jac,flag,gain]=boucle_lm_caf_auto(L,T,lda_old,nu,Hess,grad,Jac,eps2,eps1,flag,MD,MG)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning('off','MATLAB:divideByZero')
L_newv=L;
L_new={};
F= size(L{1},2);
I=size(T); % tensor dimensions
D=length(I); % tensor order (number of dimensions)
O=D-2;
Ng=length(L)-2;
I1=[I(1)*ones(1,2) I(O+1)*ones(1,Ng)];
D1=length(I1);
% reshape data tensor
Td=reshape(T,prod(I),1);

% old error and cost function value
p_old= zeros(sum(I1)*F,1);
k=1;
for i=1:D1
    p_old(k:k-1+I1(i)*F)=vec(L{i}.');
    k=k+I1(i)*F;
end
[Te]=model_caf_auto(L,MD,0);
Tde=reshape(Te,prod(I),1);
e_old= Tde - Td;
f_old= e_old'*e_old/(2);


% step
dp= -inv(Hess + lda_old*I_(sum(I1)*F))*grad;

if norm(dp)<eps2*(norm(p_old)+eps2);
    flag=1;
    %f_new=f_old;
    lda_new=lda_old;
    e_new=e_old;
    gain=0;
else 
    % update p-vector
    p_new= p_old + dp;
    % rebuild factor matrices
    k=1;
    for i=1:D1
        L_new{i}=unvec(p_new(k:k-1+I1(i)*F),F,I1(i)).';
        k=k+I1(i)*F;
    end
    % new error and cost function value
    [Te]=model_caf_auto(L_new,MD,0);
    Tde=reshape(Te,prod(I),1);
    e_new= Tde - Td;
    f_new= e_new'*e_new/(2);
    Jp=(Jac*dp)';
    f_new_approx = f_old + Jp*e_old + Jp*Jp'/2;
    
    % calculate gain ratio
    gain= ((f_old - f_new)/(f_old - f_new_approx));
    
    % update lambda (regularization factor)
    
    %%% Strategy 1
    %     if gain >.75
    %         lda_new=lda_old/3;
    %         L_newv=L_new;
    % %        [Hess,Jac]=construct_Hessian(L_new,T);
    % %        grad=construct_gradient(L_new,T);
    %             [Hess,Jac,grad]=construct_jacobian_IF(L_new,T);
    %         flag=(max(grad)<eps1);
    %     elseif gain <.25
    %         lda_new=lda_old*2;
    %         L_newv=L;
    %
    %     else
    %         lda_new=lda_old;
    %         L_newv=L_new;
    % %         [Hess,Jac]=construct_Hessian(L_new,T);
    % %         grad=construct_gradient(L_new,T);
    %  [Hess,Jac,grad]=construct_jacobian_IF(L_new,T);
    %  end

    %%% Strategy 2
    if gain >0
        lda_new=lda_old*max(1/3,1-(2*gain-1)^3);
        nu=2;
        L_newv=L_new;
        [Hess,Jac,grad]=construct_jacobian_caf_auto2(L_new,T,MD,MG);
        flag=(max(grad)<eps1);
    else
        lda_new=lda_old*nu;
        nu=2*nu;
       e_new=e_old;
    end

end
res=e_new'*e_new/2;
