function caf_eval_c;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Main function which allow to test the lemacafc algorithm
%All the paramaters must be set in the body of the function.
%typeS: Sources constellation type (ex '4qam', '8psk')
%nbs: sources number
%nbc: mixtures number
%nbo: observations number (inf simulates an infinite number of observation)
%snr: signal to noise ratio (if set to inf, no noise is added)
%ordre is the derivation order.
%nu: grid size.
%fac: grid points belong to [-fac; fac]^nbc.
%niter is the maximal number of iteration allowed to the algorithm

warning 'off'

ordre=3;
col='k';
nu=4;
fac=1;
niter=30;
snr=inf;
nbo=100000;
nbs=4;
nbc=3;
ini=0;
B=((randn(nbc,nbo)+j*randn(nbc,nbo)))/sqrt(2); %Noise matrix
[Data]=create_data(typeS,nbs,3,nbo,snr,1,B);%Create data (sources, mixture and observations)
[X S H]=Data{1,[1 2 3]};
switch ordre
    case 2
        [He,errH,res]=LEMACAFC2(X,nu,fac,nbs,niter,ini,col,H);
    case 3
        [He,errH,res]=LEMACAFC3(X,nu,fac,nbs,niter,ini,col,H);
    otherwise
        [He,errH,res]=LEMACAFC_auto(X,nu,fac,nbs,niter,ini,col,H);
end
sqrt(errH)
He
H
res
        
      
    
