function [Hes,Jac,grad]=construct_jacobian_caf_C4(L,T)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Hes=[];
% Jac=[];
% grad=[];

N=size(L{1},1);
R=size(L{3},1);
K=size(L{1},2);


A=L{1};
B=L{2};
G1=L{3};
G2=L{4};
G3=L{5};
G4=L{6};

P=N*N*N*R;
Q=(2*N+4*R)*K;


% initialize Jacobian matrix
Jac1= zeros(P,Q);
Jac2= zeros(P,Q);
Jac3= zeros(P,Q);
Jac4= zeros(P,Q);
for p=1:P
    k=floor((p-1)/(N*N*N))+1;
    x1=p-(k-1)*N*N*N;
    i3=floor((x1-1)/(N*N))+1;
    x2=x1-(i3-1)*N*N;
    i2=floor((x2-1)/(N))+1;
    i1=x2-(i2-1)*N;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%JAC1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for t=1:K
        for n=[i1 i2 i3]
            Jac1(p,(n-1)*K+t)=(i1==n)*(A(i2,t)*A(i3,t)*G1(k,t)-A(i2,t)*B(i3,t)*G2(k,t)-B(i2,t)*A(i3,t)*G2(k,t)+B(i2,t)*B(i3,t)*G3(k,t))...
                +(i2==n)*(A(i1,t)*A(i3,t)*G1(k,t)-A(i1,t)*B(i3,t)*G2(k,t)-B(i1,t)*A(i3,t)*G2(k,t)+B(i1,t)*B(i3,t)*G3(k,t))...
                +(i3==n)*(A(i1,t)*A(i2,t)*G1(k,t)-A(i1,t)*B(i2,t)*G2(k,t)-B(i1,t)*A(i2,t)*G2(k,t)+B(i1,t)*B(i2,t)*G3(k,t));

            Jac1(p,N*K+(n-1)*K+t)=(i1==n)*(-A(i2,t)*A(i3,t)*G2(k,t)+A(i2,t)*B(i3,t)*G3(k,t)+B(i2,t)*A(i3,t)*G3(k,t)-B(i2,t)*B(i3,t)*G4(k,t))...
                +(i2==n)*(-A(i1,t)*A(i3,t)*G2(k,t)+A(i1,t)*B(i3,t)*G3(k,t)+B(i1,t)*A(i3,t)*G3(k,t)-B(i1,t)*B(i3,t)*G4(k,t))...
                +(i3==n)*(-A(i1,t)*A(i2,t)*G2(k,t)+A(i1,t)*B(i2,t)*G3(k,t)+B(i1,t)*A(i2,t)*G3(k,t)-B(i1,t)*B(i2,t)*G4(k,t));
        end
        Jac1(p,2*N*K+(k-1)*K+t)=A(i1,t)*A(i2,t)*A(i3,t);
        Jac1(p,2*N*K+R*K+(k-1)*K+t)=-A(i1,t)*A(i2,t)*B(i3,t)-A(i1,t)*B(i2,t)*A(i3,t)-B(i1,t)*A(i2,t)*A(i3,t);
        Jac1(p,2*N*K+2*R*K+(k-1)*K+t)=A(i1,t)*B(i2,t)*B(i3,t)+B(i1,t)*A(i2,t)*B(i3,t)+B(i1,t)*B(i2,t)*A(i3,t);
        Jac1(p,2*N*K+3*R*K+(k-1)*K+t)=-B(i1,t)*B(i2,t)*B(i3,t);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%JAC2%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for t=1:K
        for n=[i1 i2 i3]
            Jac2(p,(n-1)*K+t)=(i1==n)*(A(i2,t)*B(i3,t)*G1(k,t)+A(i2,t)*A(i3,t)*G2(k,t)-B(i2,t)*B(i3,t)*G2(k,t)-B(i2,t)*A(i3,t)*G3(k,t))...
                +(i2==n)*(A(i1,t)*B(i3,t)*G1(k,t)+A(i1,t)*A(i3,t)*G2(k,t)-B(i1,t)*B(i3,t)*G2(k,t)-B(i1,t)*A(i3,t)*G3(k,t))...
                +(i3==n)*(A(i1,t)*A(i2,t)*G2(k,t)-A(i1,t)*B(i2,t)*G3(k,t)-B(i1,t)*A(i2,t)*G3(k,t)+B(i1,t)*B(i2,t)*G4(k,t));

            Jac2(p,N*K+(n-1)*K+t)=(i1==n)*(-A(i2,t)*B(i3,t)*G2(k,t)-A(i2,t)*A(i3,t)*G3(k,t)+B(i2,t)*B(i3,t)*G3(k,t)+B(i2,t)*A(i3,t)*G4(k,t))...
                +(i2==n)*(-A(i1,t)*B(i3,t)*G2(k,t)-A(i1,t)*A(i3,t)*G3(k,t)+B(i1,t)*B(i3,t)*G3(k,t)+B(i1,t)*A(i3,t)*G4(k,t))...
                +(i3==n)*(A(i1,t)*A(i2,t)*G1(k,t)-A(i1,t)*B(i2,t)*G2(k,t)-B(i1,t)*A(i2,t)*G2(k,t)+B(i1,t)*B(i2,t)*G3(k,t));
        end
        Jac2(p,2*N*K+(k-1)*K+t)=A(i1,t)*A(i2,t)*B(i3,t);
        Jac2(p,2*N*K+R*K+(k-1)*K+t)=A(i1,t)*A(i2,t)*A(i3,t)-A(i1,t)*B(i2,t)*B(i3,t)-B(i1,t)*A(i2,t)*B(i3,t);
        Jac2(p,2*N*K+2*R*K+(k-1)*K+t)=-A(i1,t)*B(i2,t)*A(i3,t)-B(i1,t)*A(i2,t)*A(i3,t)+B(i1,t)*B(i2,t)*B(i3,t);
        Jac2(p,2*N*K+3*R*K+(k-1)*K+t)=B(i1,t)*B(i2,t)*A(i3,t);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%JAC3%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for t=1:K
        for n=[i1 i2 i3]
            Jac3(p,(n-1)*K+t)=(i1==n)*(B(i2,t)*B(i3,t)*G2(k,t)+B(i2,t)*A(i3,t)*G3(k,t)+A(i2,t)*B(i3,t)*G3(k,t)+A(i2,t)*A(i3,t)*G4(k,t))...
                +(i2==n)*(B(i1,t)*B(i3,t)*G2(k,t)+B(i1,t)*A(i3,t)*G3(k,t)+A(i1,t)*B(i3,t)*G3(k,t)+A(i1,t)*A(i3,t)*G4(k,t))...
                +(i3==n)*(B(i1,t)*B(i2,t)*G2(k,t)+B(i1,t)*A(i2,t)*G3(k,t)+A(i1,t)*B(i2,t)*G3(k,t)+A(i1,t)*A(i2,t)*G4(k,t));

            Jac3(p,N*K+(n-1)*K+t)=(i1==n)*(B(i2,t)*B(i3,t)*G1(k,t)+B(i2,t)*A(i3,t)*G2(k,t)+A(i2,t)*B(i3,t)*G2(k,t)+A(i2,t)*A(i3,t)*G3(k,t))...
                +(i2==n)*(B(i1,t)*B(i3,t)*G1(k,t)+B(i1,t)*A(i3,t)*G2(k,t)+A(i1,t)*B(i3,t)*G2(k,t)+A(i1,t)*A(i3,t)*G3(k,t))...
                +(i3==n)*(B(i1,t)*B(i2,t)*G1(k,t)+B(i1,t)*A(i2,t)*G2(k,t)+A(i1,t)*B(i2,t)*G2(k,t)+A(i1,t)*A(i2,t)*G3(k,t));
        end
        Jac3(p,2*N*K+(k-1)*K+t)=B(i1,t)*B(i2,t)*B(i3,t);
        Jac3(p,2*N*K+R*K+(k-1)*K+t)=B(i1,t)*B(i2,t)*A(i3,t)+B(i1,t)*A(i2,t)*B(i3,t)+A(i1,t)*B(i2,t)*B(i3,t);
        Jac3(p,2*N*K+2*R*K+(k-1)*K+t)=B(i1,t)*A(i2,t)*A(i3,t)+A(i1,t)*B(i2,t)*A(i3,t)+A(i1,t)*A(i2,t)*B(i3,t);
        Jac3(p,2*N*K+3*R*K+(k-1)*K+t)=A(i1,t)*A(i2,t)*A(i3,t);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%JAC4%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for t=1:K
        for n=[i1 i2 i3]
            Jac4(p,(n-1)*K+t)=(i1==n)*(B(i2,t)*A(i3,t)*G2(k,t)-B(i2,t)*B(i3,t)*G3(k,t)+A(i2,t)*A(i3,t)*G3(k,t)-A(i2,t)*B(i3,t)*G4(k,t))...
                +(i2==n)*(B(i1,t)*A(i3,t)*G2(k,t)-B(i1,t)*B(i3,t)*G3(k,t)+A(i1,t)*A(i3,t)*G3(k,t)-A(i1,t)*B(i3,t)*G4(k,t))...
                +(i3==n)*(B(i1,t)*B(i2,t)*G1(k,t)+B(i1,t)*A(i2,t)*G2(k,t)+A(i1,t)*B(i2,t)*G2(k,t)+A(i1,t)*A(i2,t)*G3(k,t));
            
            Jac4(p,N*K+(n-1)*K+t)=(i1==n)*(B(i2,t)*A(i3,t)*G1(k,t)-B(i2,t)*B(i3,t)*G2(k,t)+A(i2,t)*A(i3,t)*G2(k,t)-A(i2,t)*B(i3,t)*G3(k,t))...
                +(i2==n)*(B(i1,t)*A(i3,t)*G1(k,t)-B(i1,t)*B(i3,t)*G2(k,t)+A(i1,t)*A(i3,t)*G2(k,t)-A(i1,t)*B(i3,t)*G3(k,t))...
                +(i3==n)*(-B(i1,t)*B(i2,t)*G2(k,t)-B(i1,t)*A(i2,t)*G3(k,t)-A(i1,t)*B(i2,t)*G3(k,t)-A(i1,t)*A(i2,t)*G4(k,t));
        end
        Jac4(p,2*N*K+(k-1)*K+t)=B(i1,t)*B(i2,t)*A(i3,t);
        Jac4(p,2*N*K+R*K+(k-1)*K+t)=-B(i1,t)*B(i2,t)*B(i3,t)+B(i1,t)*A(i2,t)*A(i3,t)+A(i1,t)*B(i2,t)*A(i3,t);
        Jac4(p,2*N*K+2*R*K+(k-1)*K+t)=-B(i1,t)*A(i2,t)*B(i3,t)-A(i1,t)*B(i2,t)*B(i3,t)+A(i1,t)*A(i2,t)*A(i3,t);
        Jac4(p,2*N*K+3*R*K+(k-1)*K+t)=-A(i1,t)*A(i2,t)*B(i3,t);
    end
end

Jac=[Jac1;Jac2;Jac3;Jac4];

 %return

P=4*P;
Hes=Jac'*Jac;
Td=reshape(T,P,1);
[Te]=model_caf_C3(L);
Tde=reshape(Te,P,1);
err= Tde - Td;
grad=Jac'*err;
