function [Hess,Jac,grad]=construct_jacobian_caf_auto2(L,T,MD,MG)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
O=length(size(T))-2;
M2=mat_bin(O-1);
Np=size(MD,1);
Th(1,:,:)=L{1};
Th(2,:,:)=L{2};
N=size(Th,2);
K=size(Th,3);
G={};
for i=1:length(L)-2
    G{i}=L{i+2};
end
a=G{1};
R=size(a,1);
dimT=size(T);
P=prod(dimT(1:end-1));
Q=(2*N+(O+1)*R)*K;


% initialize Jacobian matrix
Jac1= zeros(P,Q);
Jac=[];

for np=1:Np %boucle sur le nombre d'�quations
    ind=MD(np,:);

    for p=1:P%boucle sur les lignes du jacobien
        k=floor((p-1)/(N^O))+1;
        y=k;
        x=p;
        for o=O:-1:2
            x=x-(y-1)*N^o;
            i(o)=floor((x-1)/(N^(o-1)))+1;
            y=i(o);
        end
        i(1)=x-(i(2)-1)*N;
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%JACA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        for t=1:K
            for n=i %JA et JB
                Jac1(p,(n-1)*K+t)=0;
                Jac1(p,N*K+(n-1)*K+t)=0;
                ind2=i;
                ind3=ind;
                for os1=1:O
                    ind2(os1)=[];
                    sup=ind3(os1);
                    ind3(os1)=[];
                    JA2=0;
                    JB2=0;
                    for os2=1:2^(O-1)
                        ind1=M2(os2,:) ;
                        zA1=sum(xor(ind1,ind3))+sup;
                        sigA=(-1)^sum(ind1 & not(ind3));
                        JA1=sigA*G{zA1+1}(k,t);
                        zB1=sum(xor(ind1,ind3))+not(sup);
                        sigB=(-1)^sum(ind1 & not(ind3))*(-1)^(not(sup));
                        JB1=sigB*G{zB1+1}(k,t);
                        for op=1:O-1
                            z=ind1(op)+1;
                            m=ind2(op);
                            %Th(z,m,t);
                            JA1=JA1*Th(z,m,t);
                            JB1=JB1*Th(z,m,t);
                        end
                        JA2=JA2+JA1;
                        JB2=JB2+JB1;
                    end
                    Jac1(p,(n-1)*K+t)=Jac1(p,(n-1)*K+t)+(i(os1)==n)*JA2;
                    Jac1(p,N*K+(n-1)*K+t)=Jac1(p,N*K+(n-1)*K+t)+(i(os1)==n)*JB2;
                    ind2=i;
                    ind3=ind;
                end
            end
            for g=1:length(L)-2 %boucle pour JG
                Mg=squeeze(MG{g}(np,:,:));
                if size(Mg,2)==1
                    Mg=Mg';
                end
                Jac1(p,2*N*K+(g-1)*R*K+(k-1)*K+t)=0;
                for os=1:size(Mg,1)
                    J1=Mg(os,end);
                    for op=1:size(Mg,2)-1
                        m=i(op);
                        J1=J1*Th(Mg(os,op)+1,m,t);
                    end
                    Jac1(p,2*N*K+(g-1)*R*K+(k-1)*K+t)=Jac1(p,2*N*K+(g-1)*R*K+(k-1)*K+t)+J1;
                end
            end
        end
    end
    Jac=[Jac;Jac1];
end

P=P*Np;
Hess=Jac'*Jac;
Td=reshape(T,P,1);
[Te]=model_caf_auto(L,MD,0);
Tde=reshape(Te,P,1);
err= Tde - Td;
grad=Jac'*err;
