
function [W]=create_gfT(Z,nu,fac);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create the caf derivation tensor T.
%Z is the observation matrix.
%complexGF: 1 if the mixing matrix is complex or 0 if it is real.
%ordre is the differentiation order. Ord can be 2, 3 or 4 in the complex case or
%3, 4 or 43 in the real case (43 merge order 3 and 4 in a 4 ways tensor).
%nu is the grid size.
%fac: grid points belong to [-fac; fac]^nbc.

nbc=size(Z,1);
a=-fac;
b=fac;
k=0;
W=zeros(nbc,nu);
% ind=[nbc*ones(1,ordre) nu 4];
% T=zeros(ind);
for r=1:nu
    flag=1;
    while flag==1
         w=(b-a)*rand(nbc,1)+a+((b-a)*rand(nbc,1)+a)*i;
        expo=exp(real(w'*Z));
        phi=mean(expo);
        if (phi)>0
            flag=0;
             W(:,r)=w;
            k=k+1;
        end
    end
end
rank(W);
 

       
