function S=generate_symbols(nbs,nbo,typeS);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%% distribution uniforme continue entre (0,1)
S=rand(nbs,nbo);


switch typeS
    
    case '4pam'
%%% codage 4-PAM des symboles sources
% (selon un partitionnement en 4 intervalles de meme longueur)
S(S<.25)          =   1; 
S(S>=.25 & S<.5)  =   1/3;
S(S>=.5  & S<.75) =   -1/3;
S(S>=.75 & S<1)   =   -1;

    case '4qam'
%%% codage 4-QAM des symboles sources
% (selon un partitionnement en 4 intervalles de meme longueur)
S(S<.25)          =   1+j; 
S(S>=.25 & S<.5)  =  -1+j;
S(S>=.5  & S<.75) =  -1-j;
S(S>=.75 & S<1)   =   1-j;

    case '8psk'
%%% codage 8-PSK des symboles sources
% (selon un partitionnement en 8 intervalles de meme longueur)
a=exp(j*2*pi/8);
S(S<1/8)           =   a^0; 
S(S>=1/8 & S<2/8)  =   a^1;
S(S>=2/8 & S<3/8)  =   a^2;
S(S>=3/8 & S<4/8)  =   a^3;
S(S>=4/8 & S<5/8)  =   a^4;
S(S>=5/8 & S<6/8)  =   a^5;
S(S>=6/8 & S<7/8)  =   a^6;
S(S>=7/8)          =   a^7;

case '4psk'
    for i=1:nbs
        S(i,:)=vpsk(nbo,4);
    end


end




%% REMARQUE: 
%% Pour d'autres modulations (soit M-PAM, M-QAM ou M-PSK), nous suivons
%% le meme raisonnement des exemples ci-dessus, avec un
%% partitionnement uniforme en M intervalles.
