function [T]=model_caf_C4(L);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A=L{1};
B=L{2};
G1=L{3};
G2=L{4};
G3=L{5};
G4=L{6};

R=size(G1,1);
N=size(A,1);


T=zeros(N,N,N,R,4);
T(:,:,:,:,1)=tenseur({A,A,A,G1})-tenseur({A,A,B,G2})-tenseur({A,B,A,G2})+tenseur({A,B,B,G3})...
    -tenseur({B,A,A,G2})+tenseur({B,A,B,G3})+tenseur({B,B,A,G3})-tenseur({B,B,B,G4});

T(:,:,:,:,2)=tenseur({A,A,B,G1})+tenseur({A,A,A,G2})-tenseur({A,B,B,G2})-tenseur({A,B,A,G3})...
    -tenseur({B,A,B,G2})-tenseur({B,A,A,G3})+tenseur({B,B,B,G3})+tenseur({B,B,A,G4});

T(:,:,:,:,3)=tenseur({B,B,B,G1})+tenseur({B,B,A,G2})+tenseur({B,A,B,G2})+tenseur({B,A,A,G3})...
    +tenseur({A,B,B,G2})+tenseur({A,B,A,G3})+tenseur({A,A,B,G3})+tenseur({A,A,A,G4});

T(:,:,:,:,4)=tenseur({B,B,A,G1})-tenseur({B,B,B,G2})+tenseur({B,A,A,G2})-tenseur({B,A,B,G3})...
    +tenseur({A,B,A,G2})-tenseur({A,B,B,G3})+tenseur({A,A,A,G3})-tenseur({A,A,B,G4});





