function [L_new,res,grad_new]=boucle_grad_opt(L,T,lda,grad)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Compute one iteration of the gradient method with els

nbs= size(L{1},2);
I=size(T); % tensor dimensions
D=length(I); % tensor order (number of dimensions)
Td=reshape(T,prod(I),1);
% old error and cost function value
p= zeros(sum(I)*nbs,1);
x= ones(1,nbs);
k=1;
for i=1:D
    p(k:k-1+I(i)*nbs)=vec(L{i}.');
    x=pkr(L{i},x);
    k=k+I(i)*nbs;
end
% gradient vector



% update p-vector
p_new= p -lda*grad;

% rebuild factor matrices
k=1;
for i=1:D
    L_new{i}=unvec(p_new(k:k-1+I(i)*nbs),nbs,I(i)).';
    k=k+I(i)*nbs;
end


x_new=ones(1,nbs);
for i=1:D
    x_new=pkr(L_new{i},x_new);
end
e_new= x_new*ones(nbs,1) - Td;
f_new= e_new'*e_new/(2);

grad_new=construct_gradient(L_new,T);

res=e_new'*e_new/sum((Td(:)).^2);


