function [L_newv,res,lda_new,nu,Hess,grad,Jac,flag,gain]=boucle_lm_sym4(L,T,lda_old,nu,Hess,grad,Jac,eps2,eps1,flag,index)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L_newv=L;
F= size(L{1},2);
I=size(T); % tensor dimensions
D=length(I); % tensor order (number of dimensions)

% reshape data tensor
Td=reshape(T,prod(I),1);

% old error and cost function value
p_old= zeros(sum(I(1:2))*F,1);
x_old= ones(1,F);
k=1;
for i=1:D
    if i<=2
        p_old(k:k-1+I(i)*F)=vec(L{i}.');
    end
    x_old=pkr(L{i},x_old);
    k=k+I(i)*F;
end
e_old= x_old*ones(F,1) - Td;
f_old= e_old'*e_old/(2);


% step
dp= -inv(Hess + lda_old*I_(sum(I(1:2))*F))*grad;

if norm(dp)<eps2*(norm(p_old)+eps2);
    flag==1;
    f_new=f_old;
    lda_new=lda_old;
    gain=0;
else 
    % update p-vector
    p_new= p_old + dp;
    % rebuild factor matrices
    k=1;
    for i=1:D
        if i<=2
            L_new{i}=unvec(p_new(k:k-1+I(i)*F),F,I(i)).';
            k=k+I(i)*F;
        else
            L_new{i}=L_new{2};
        end
    end

    % new error and cost function value
    x_new=ones(1,F);
    for i=1:D
        x_new=pkr(L_new{i},x_new);
    end
    e_new= x_new*ones(F,1) - Td;
    f_new= e_new'*e_new/(2);
    Jp=(Jac*dp)';
    f_new_approx = f_old + Jp*e_old + Jp*Jp'/2;
    %den=-dp'*grad-0.5*dp'*Hess*dp;
    % calculate gain ratio
    gain= ((f_old - f_new)/(f_old - f_new_approx));
    
    % update lambda (regularization factor)
    %%% Strategy 1
%     if gain >.75
%         lda_new=lda_old/3;
%         L_newv=L_new;
%         [Hess,Jac]=construct_Hessian(L_new,T);
%         grad=construct_gradient(L_new,T);
%         flag=(max(grad)<eps1);
%     elseif gain <.25
%         lda_new=lda_old*2;
%         L_newv=L;
%    
%     else
%         lda_new=lda_old;
%         L_newv=L;
% %         [Hess,Jac]=construct_Hessian(L_new,T);
% %         grad=construct_gradient(L_new,T);
%     end

    %%% Strategy 2
    if gain >0
        lda_new=lda_old*max(1/3,1-(2*gain-1)^3);
        nu=2;
        L_newv=L_new;
        [Hess,Jac]=construct_Hessian2(L_new,T);
        grad=construct_gradient2(L_new,T,index);
        flag=(max(grad)<eps1);
    else
        lda_new=lda_old*nu;
        nu=2*nu;
        f_new=f_old;
    end

end
res=e_new'*e_new/sum((Td(:)).^2);
