function [L_new,res,d_new,grad,delta_new,cpt]=boucle_nlcg(L,T,d,grad,delta_old,cpt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Conjugate gradient iteration

jmax=10;
eps1=0;%1e-20;
F= size(L{1},2);
I=size(T); % tensor dimensions
D=length(I); % tensor order (number of dimensions)
% reshape data tensor
Td=reshape(T,prod(I),1);
Td2=reshape(T,[I(1) prod(I(2:end))]);
N=size(Td2,2);
% old error and cost function value
p_old= zeros(sum(I)*F,1);
x_old= ones(1,F);
k=1;
for i=1:D
    p_old(k:k-1+I(i)*F)=vec(L{i}.');
    x_old=pkr(L{i},x_old);
    k=k+I(i)*F;
end
r_old=-grad;

k=1;
for i=1:D
    K{i,1}=unvec(d(k:k-1+I(i)*F),F,I(i)).';
    k=k+I(i)*F;
    K{i,2}=L{i};
end
alpha=els(Td2,K,N,F);
p=p_old+alpha*d;
k=1;
for i=1:D
    L_new{i}=unvec(p(k:k-1+I(i)*F),F,I(i)).';
    k=k+I(i)*F;
end

grad=construct_gradient(L_new,T);

x_new=ones(1,F);
for i=1:D
    x_new=pkr(L_new{i},x_new);
end
e_new= x_new*ones(F,1) - Td;
f_new= e_new'*e_new;
res=e_new'*e_new/sum((Td(:)).^2);
r=-grad;
delta_new=r'*r;
delta1=r'*r_old;
%beta=delta_new/delta_old;
beta=(delta_new-delta1)/delta_old;
d_new=r+beta*d;
% cpt=cpt+1;
% if   r'*d_new<=0 || cpt==length(p)
%     d_new=r;
%     cpt=0;
% end  


