function [eH]=caf_eval;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Main function which allow to test the caf approach 
%All the paramaters must be set in the body of the function.
%typeS: Sources constellation type (ex '2psk')
%complexH: 1 for a complex mixing matrix or 0 for a real one.
%nbs: sources number
%nbc: mixtures number 
%nbo: observations number (inf simulates an infinite number of observation)
%snr: signal to noise ratio (if set to inf, no noise is added) 
%num: save files index
%ordre is the derivation order. Ord can be 2, 3 or 4 in the complex case or
%3, 4 or 43 in the real case (43 merge order 3 and 4 in a 4 ways tensor).
%nu: grid size.
%fac: grid points belong to [-fac; fac]^nbc.
%Algo: string specifying the algorithm: 'als' for ALESCAF, 'grad' for
%GRADCAF, 'lm' for LEMACAF or 'nlcg' for CGRADCAF
%nbtest: number of random initialisations to be compared. The best
%initialisation up to the initial fit is chosen.
%niter is the maximal number of iteration allowed to the algorithm
%elsper is the ELS cycle, 0 means no ELS
%tol: Algorithm stop if the fit amelioration between successive iterations is less than
%tol.

%Data parameters
typeS='2qam';
complexH=1;
nbs=4;
nbc=3;
nbo=inf;
snr=inf;
num=2;
%Algorithm parameters:
ordre=3;
nu=4;
fac=1; %mettre 1 pour le gradient !
nbtest=1000;
niter=2000;
elsper=5;
algo='als';
tol=1e-15;
ini=1;
col='k'

if ini==0
    load tensor
else
    %Create data
    [Data,pData]=create_data(typeS,complexH,nbs,nbc,nbo,snr,num);
    [X H]=Data{1,[1 3]};
    %Estimation
    T=create_gfT(X,complexH,nu,fac,ordre);
    save tensor T X H
end
[Le,err_old]=choix_ini(T,nbs,nbtest,ini);
[He,eH,err_new]=parafac_dec(T,nbs,tol,complexH,algo,niter,elsper,Le,err_old,col,H);

%NMSE
eH




