function [Le,err_old]=choix_ini(T,nbs,nbtest,ini)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Intitialisation of the PARFAC decomposition
%nbtest is the number of compared initialisation. The best initialisation
%up to the fit is chosen.
%Le is a cell array containing initial guess of the loading matrices
%err_old is the corresponding reconstruction error
if ini==0
    load Lini
else
    I=size(T);
    D=length(I);
    err_old=1e20;
    for i=1:nbtest
        L{1}=(randn(I(1),nbs));
        L{2}=(randn(I(2),nbs));
        for d=3:D;
            L{d}=L{2};
        end
        Z0= ones(1,nbs);
        for d=1:D
            Z0=pkr(L{d},Z0);
        end
        Td0=Z0*ones(nbs,1);
        Td=reshape(T,prod(I),1);
        err_old1= norm(Td-Td0);
        if err_old1<err_old
            Le=L;
            err_old=err_old1;
        end
    end
    save Lini Le err_old
end
