function Ln=permscal2(L,Lv);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Removes the permutation and the scaling indeterminancy in the loading
% matrices stored in L from the real matrices stored in Lv 

X=L{1};
complexGF=any(imag(X(:)));
N=length(L);
F=size(L{1},2);
X=[];
Xv=[];



for n=1:N
    A=L{n};
    Av=Lv{n};
    t=size(A,1);
    
    for i=1:F
        a(1:2:2*t-1)=real(A(:,i));
        a(2:2:2*t)=imag(A(:,i));
        An(:,i)=abs(a)/norm(abs(a));
        a(1:2:2*t-1)=real(Av(:,i));
        a(2:2:2*t)=imag(Av(:,i));
        Avn(:,i)=abs(a)/norm(abs(a)); 
%         An(1:2:2*t-1,i)=real(A(:,i)/A(1,i));
%         An(2:2:2*t,i)=imag(A(:,i)/A(1,i));
%         Avn(1:2:2*t-1,i)=real(Av(:,i)/Av(1,i));
%         Avn(2:2:2*t,i)=imag(Av(:,i)/Av(1,i));
    end
    X=[X;An];
    Xv=[Xv;Avn];
end


P=perms(1:F);

for i=1:size(P,1)
    r(i)=norm(Xv-X(:,P(i,:)));
end
[m,pos]=min(r);
p=P(pos,:);
Ln=L;

for n=1:N
    A=L{n}(:,p);
    Av=Lv{n};
    t=size(A,1);
    teta=zeros(size(A,1),1);
    for i=1:F
        for k=1:size(A,1)
            teta(k)=angle(mean(A(k,i)*Av(:,i)./A(:,i)));
        end
        Ln{n}(:,i)=(norm(abs(Av(:,i)))*abs(A(:,i))/norm(abs(A(:,i)))).*exp(j*teta);
    end
    if complexGF==0
        Ln{n}=real(Ln{n});
    end
end


